unit FormMain;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  Grids, StdCtrls, Buttons, Arrow;

type

  { TMainForm }

  TMainForm = class(TForm)
    ArrowGoLeft: TArrow;
    ArrowGoUp: TArrow;
    ArrowGoRight: TArrow;
    ArrowGoDown: TArrow;
    ButtonNewGame: TButton;
    ButtonExit: TButton;
    ControlPanel: TPanel;
    MinesLabel: TLabel;
    PointsLabel: TLabel;
    PointsTitleLabel: TLabel;
    MinesTitleLabel: TLabel;
    LevelLabel: TLabel;
    LevelTitleLable: TLabel;
    HeadingStaticText: TStaticText;
    Pitch: TStringGrid;
    procedure ArrowGoUpClick(Sender: TObject);
    procedure ButtonExitClick(Sender: TObject);
    procedure ButtonNewGameClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure InitializePitch(NumberOfMines : Integer);
  private
    { private declarations }
  public
    { public declarations }
  end;

  TPosition = record
    X : Integer;
    Y : Integer;
  end;

const
  Player = 'P';
  Target = 'T';
  Mine = 'X';
  NumberOfColumns = 40;
  NumberOfRows = 30;

var
  MainForm: TMainForm;
  FPlayer : TPosition;
  FLevel : Integer;

implementation

{$R *.lfm}

{ TMainForm }

procedure TMainForm.FormCreate(Sender: TObject);
begin
  ButtonNewGameClick(self);
end;

procedure TMainForm.InitializePitch(NumberOfMines: Integer);
var
  i : Integer;
  X, Y : Integer;
begin
  Pitch.Clean;
  { Define Playerposition}
  Pitch.Cells[NumberOfColumns div 2, NumberOfRows-1] := Player;
  { Define Targetposition}
  for i := ((NumberOfColumns div 2)-2) to ((NumberOfColumns div 2)+2) do
    Pitch.Cells[i,0] := Target;
  { Mining}
  Randomize;
  while NumberOfMines > 0 do
    begin
      X := Random(NumberOfColumns);
      Y := Random(NumberOfRows);
      { No Mines in the first and last row!}
      if (Y > 0) and (Y < NumberOfRows-1) then
        begin
          {put down mine, if it is an empty place}
          if Pitch.Cells[X,Y] = '' then
            begin
              Pitch.Cells[X,Y] := Mine;
              Dec(NumberOfMines);
            end;
        end;
    end;
end;

procedure TMainForm.ArrowGoUpClick(Sender: TObject);
begin

end;

procedure TMainForm.ButtonExitClick(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.ButtonNewGameClick(Sender: TObject);
begin
  InitializePitch(80);
end;

end.

